<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:nk="http://netkernel.org" xmlns:xrl="http://netkernel.org/xrl">
    <xsl:output method="xml"/>
	<xsl:param name="test"/>
	
	<xsl:template match="/testlist">
		<div>
			<div style="float:right">
				<img id="spinner" src="/nkse/style/img/ajax-loader.gif" style="display:none;"/>
			</div>
			<link type="text/css" rel="stylesheet" href="/tools/ae/pub/explore.css?v=6.1.1"/>
			<script language="javascript">
			<xsl:comment>
			var filtered=false;
			function exec()
			{	$("#execute").removeClass("btn-primary").addClass("btn-danger");
				$("#spinner").show();
				$(".table").hide();
				location.reload();
			}
			function filterSuccess()
			{	if(filtered)
				{	$(".xunit-filter-row").show();
					$("#filter").removeClass("btn-danger").addClass("btn-alert");
				}
				else
				{	$(".xunit-filter-row").hide();
					$("#filter").removeClass("btn-alert").addClass("btn-danger");
				}
				filtered=!filtered;
			}
			</xsl:comment>
			</script>
			<div class="row">
				<div class="col-md-9 form form-group">
					<button id="execute" class="btn btn-default" style="margin-right: 1em;" type="button" value="execute" onclick="document.location='/test/'">Tests</button>
					<button id="execute" class="btn btn-primary" type="button" value="execute" onclick="javascript:exec()"><span class="fa fa-play"> </span> execute</button>
				</div>
				<div class="col-md-3">
					<xsl:if test="results/testFailException + results/testFailAssert &gt; 0">
					<input id="filter" class="btn btn-xs btn-alert" type="button" value="show failures" onclick="javascript:filterSuccess()" />
					</xsl:if>
					<input class="btn btn-xs btn-default" type="button" value="view xml testlist" onclick="parent.location='/test/view/xml/{$test/test/id}'" />
				</div>
			</div>			
			
			<div style="margin-bottom: 10px;">
				<xsl:apply-templates select="results"/>
			</div>
			
			<table class="table table-striped" style="width: 100%;">
				<thead>
				<tr>
					<th/>
					<th width="60%">Test</th>
					<th style="text-align:right;">Time</th>
					<th>Status</th>
					<th/>
				</tr>
				</thead>
				<tbody>
				<xsl:for-each select="//test | //notest">
						 <xsl:variable name="class">
							<xsl:choose>
								<xsl:when test="name()='notest'">
									<xsl:text>xunit-notest xunit-filter-row</xsl:text>
								</xsl:when>
								<xsl:when test="@testStatus='success'">xunit-filter-row</xsl:when>
							</xsl:choose> 
					    </xsl:variable>
					<tr class="{$class}">
					    <td style="text-align: right;"><xsl:value-of select="position()"/></td>
						<td>
						<xsl:choose>
							<xsl:when test="@name">
								<xsl:value-of select="@name"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="request/identifier"/>
							</xsl:otherwise>
						</xsl:choose>
						</td>
						<td style="text-align: right;"><xsl:value-of select="request/@requestTime"/></td>
						<td align="center">
							<div style="padding: 2px;">
							 <xsl:attribute name="class">
								<xsl:choose>
								    <xsl:when test="starts-with(@testStatus,'exception')">
									<xsl:text>xunit-exception</xsl:text>
								    </xsl:when>
								    <xsl:when test="starts-with(@testStatus,'assertionFailure')">
									<xsl:text>xunit-assert</xsl:text>
								    </xsl:when>
								    <xsl:when test="starts-with(@testStatus,'assertionException') or starts-with(@testStatus,'setupException') or starts-with(@testStatus,'teardownException')">
									<xsl:text>xunit-testfail</xsl:text>
								    </xsl:when>
									<xsl:when test="name()='notest'">
										<xsl:text>xunit-notest</xsl:text>
									</xsl:when>
								    <xsl:otherwise>
									    <xsl:text>xunit-success</xsl:text>
								    </xsl:otherwise>   
								</xsl:choose> 
						    </xsl:attribute>
						
							<xsl:choose>
								<xsl:when test="name()='notest'">
									<span class="fa fa-minus"> </span>
									<span style="margin-left: 1em;"><xsl:text>notest</xsl:text></span>
								</xsl:when>
							    <xsl:otherwise>
							    	<xsl:if test="@testStatus='success'">
							    		<xsl:attribute name="class">xunit-success</xsl:attribute>
							    	</xsl:if>
							    	<xsl:choose>
									    <xsl:when test="starts-with(@testStatus,'exception')">
											<span class="fa fa-exclamation"> </span>
									    </xsl:when>
									    <xsl:when test="starts-with(@testStatus,'assertionFailure')">
											<span class="fa fa-question"> </span>
									    </xsl:when>
									    <xsl:when test="starts-with(@testStatus,'assertionException') or starts-with(@testStatus,'setupException') or starts-with(@testStatus,'teardownException')">
											<span class="fa fa-question"> </span>
									    </xsl:when>
									    <xsl:otherwise>
										    <span class="fa fa-check"> </span>
									    </xsl:otherwise>   
									</xsl:choose>
								    <span style="margin-left: 1em;"><xsl:value-of select="@testStatus"/></span>
							    </xsl:otherwise>   
							</xsl:choose>
							</div>
						</td>
						<td>
							<xsl:if test="name()='test'">
							<xsl:variable name="pos" select="1+count(preceding::test)"/>
							<button class="btn btn-xs btn-default" title="Execute individual test" style="width: 5em;" type="button" value="exec" onclick="parent.location='?index={$pos}'">
							<span class="fa fa-play"> </span>
							</button>
							</xsl:if>
						</td>
					</tr>
					<xsl:choose>
					    <xsl:when test="starts-with(@testStatus,'assertionFailure')">
							<xsl:for-each select="assert/*[@assertStatus='false']">
								<tr class="{$class}">
									<td/><td></td><td colspan="3"><b><xsl:value-of select="name()"/></b> <xsl:if test="not(@assertExpected)">: <xsl:value-of select="."/></xsl:if></td>
								</tr>
								<xsl:if test="@assertExpected or @assertReceived">
								<tr  class="{$class}">
								<td/><td></td><td colspan="3">
									<xsl:if test="@assertExpected">
										<div>Expected: <xsl:value-of select="@assertExpected"/></div>
									</xsl:if>
									<xsl:if test="@assertReceived">
										<div>Received: <xsl:value-of select="@assertReceived"/></div>
									</xsl:if>
								</td>
								</tr>
								</xsl:if>
								
							</xsl:for-each>	
					    </xsl:when>
					  </xsl:choose>
			</xsl:for-each>
			</tbody>
			</table>
		</div>
    </xsl:template>
	
	<xsl:template match="results">
		<div class="panel panel-default">
				<div class="panel-heading"><div class="panel-title">Results: <b><xsl:value-of select="$test/test/id"/></b></div></div>
		<table class="table">
		<tr>
			<th>Time</th>
			<th>Total</th>
			<th>Run</th>
			<th>Success</th>
			<th>Fail</th>
			<th>Assert</th>
			<th>Exec Time</th>
			<th>Total Time</th>
		</tr>
		<tr style="background-image: none;">
				<xsl:attribute name="class">
					<xsl:choose>
					    <xsl:when test="testFailException+testFailAssert &gt; 0">
							<xsl:text>xunit-exception</xsl:text>
					    </xsl:when>
					    <xsl:otherwise>
							<xsl:text>xunit-success</xsl:text>
					    </xsl:otherwise>
					</xsl:choose>
				   </xsl:attribute>
			<td><xsl:value-of select="testDate"/></td>
			<td align="center"><xsl:value-of select="testTotal"/></td>
			<td align="center"><xsl:value-of select="testRun"/></td>
			<td align="center"><xsl:value-of select="testSuccess"/></td>
			<td align="center"><xsl:value-of select="testFailException"/></td>
			<td align="center"><xsl:value-of select="testFailAssert"/></td>
			<td align="center"><xsl:value-of select="testExecutionTime"/></td>
			<td align="center"><xsl:value-of select="testTotalTime"/></td>
		</tr>
		</table>
		<xsl:apply-templates/>
		</div>
	</xsl:template>
		
	<xsl:template match="text()"/>
	
</xsl:stylesheet>
